// *******************************************************************
// Copyright (C) 2009 Telos Systems, TLS Corp.
// All rights reserved.
//
// No part of this source code or associated documentation may be 
// reproduced or utilized in any form or by any means, electronic or 
// mechanical, without permission in writing from TLS Corp.
// -------------------------------------------------------------------
//      File: APSend.h
// Description: See class description.
//    Author: Ioan L. Rus
//      Date: Nov 18, 2009
// Revisions: 
// -------------------------------------------------------------------
// INI Date        Description
// --- ----------- ---------------------------------------------------
// 
// *******************************************************************
#ifndef _APDECODEEVENTS_H_INCLUDED_
#define _APDECODEEVENTS_H_INCLUDED_

#include "IAPMessageReceiver.h"
#include "APMessages.h"

class CMsg2;
class IAPEvents;

// Accepts a data packet received from the server, decodes it
// and invokes the appropriate IAPEvents method.
class APDecodeEvents : public IAPMessageReceiver
{
private:
  typedef bool (APDecodeEvents::*HandlerFunctions)(CMsg2 &msg);
  HandlerFunctions m_fn[APSRVTOCLI_MAX_INDEX];
  IAPEvents *m_pEvents;

  bool HandleEnumerateShowsCallback(CMsg2 &msg);
  bool HandleEnumerateShowsForHost(CMsg2 &msg);
  bool HandleEnumerateHostsCallback(CMsg2 &msg);
  bool HandleEnumerateDirectorsCallback(CMsg2 &msg);
  bool HandleSendShowInfo(CMsg2 &msg);
  bool HandleSendMode(CMsg2 &msg);
  bool HandleSendShowChange(CMsg2 &msg);
  bool HandleSendRecord(CMsg2 &msg);
  bool HandleSendBusyAll(CMsg2 &msg);
  bool HandleSendTransfer(CMsg2 &msg);
  bool HandleSendMute(CMsg2 &msg);
  bool HandleSendRingMute(CMsg2 &msg);
  bool HandleSendDelayDump(CMsg2 &msg);
  bool HandleSendHandset(CMsg2 &msg);
  bool HandleSendSpeaker(CMsg2 &msg);
  bool HandleSendLineState(CMsg2 &msg);
  bool HandleSendSeizeLine(CMsg2 &msg);
  bool HandleSendRingLine(CMsg2 &msg);
  bool HandleSendDropLine(CMsg2 &msg);
  bool HandleSendAnswerLine(CMsg2 &msg);
  bool HandleSendSelectLine(CMsg2 &msg);
  bool HandleSendDialKey(CMsg2 &msg);
  bool HandleSendText(CMsg2 &msg);
  bool HandleSendError(CMsg2 &msg);

  bool HandleLoginResult(CMsg2 &msg);

public:
  APDecodeEvents(IAPEvents *pEvents);

  // IAPMessageReceiver
  bool OnMessage(const char *pData,unsigned cbData);
};

#endif // _APDECODEEVENTS_H_INCLUDED_
