// *******************************************************************
// Copyright (C) 2009 Telos Systems, TLS Corp.
// All rights reserved.
//
// No part of this source code or associated documentation may be 
// reproduced or utilized in any form or by any means, electronic or 
// mechanical, without permission in writing from TLS Corp.
// -------------------------------------------------------------------
//      File: APSend.h
// Description: See class description.
//    Author: Ioan L. Rus
//      Date: Nov 18, 2009
// Revisions: 
// -------------------------------------------------------------------
// INI Date        Description
// --- ----------- ---------------------------------------------------
// 
// *******************************************************************
#include "APMessageParser.h"
#include "IAPMessageReceiver.h"

bool APMessageParser::PushChar(char ch)
{
  switch(m_eState)
  {
  case PARSING_SIZE1:
    m_size1.m_aBytes[3-m_nDataCount++]=(unsigned char)ch;
    if(m_nDataCount>=4)
    {
      m_nDataCount=0;

      if(m_size1.m_dword>MAX_BUFFER) return false;

      m_eState=PARSING_SIZE2;
    }
    break;

  case PARSING_SIZE2:
    m_size2.m_aBytes[3-m_nDataCount++]=(unsigned char)ch;
    if(m_nDataCount>=4)
    {
      m_nDataCount=0;

      m_size2.m_dword^=0xA5A55A5A;
      if(m_size1.m_dword!=m_size2.m_dword)
      {
        m_eState=PARSING_SIZE1;
        return false;
      }
      m_eState=PARSING_DATA;
    }
    break;

  case PARSING_DATA:
    m_aData[m_nDataCount++]=ch;
    if(m_nDataCount>=m_size1.m_dword)
    {
      m_nDataCount=0;
      m_eState=PARSING_SIZE1;

      if(m_pReceiver!=0) return m_pReceiver->OnMessage(m_aData,m_size1.m_dword);
    }
    break;

  default:
    return false;
  }

  return true;
}

